﻿Type=StaticCode
Version=5.9
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	Private client As Socket
	Public server As ServerSocket
	Private astream As AsyncStreams
	Private const PORT As Int = 51042
	Private working As Boolean = True
	Public FileNumber As Int
	
End Sub

Sub StartServer
	server.Initialize(PORT, "server")
	ListenForConnections
	UpdateState(False)
End Sub

Private Sub ListenForConnections
	Do While working
		server.Listen
		Wait For Server_NewConnection (Successful As Boolean, NewSocket As Socket)
		If Successful Then
			CloseExistingConnection
			client = NewSocket
			astream.InitializePrefix(client.InputStream, False, client.OutputStream, "astream")
			UpdateState(True)
			Log("Connected...")
		End If
	Loop
End Sub

Sub CloseExistingConnection
	If astream.IsInitialized Then astream.Close
	If client.IsInitialized Then client.Close
	UpdateState (False)
End Sub

Sub AStream_Error
	UpdateState(False)
End Sub

Sub AStream_Terminated
	UpdateState(False)
End Sub

Sub UpdateState (NewState As Boolean)
	
End Sub

Sub AStream_NewData (Buffer() As Byte)
	Dim Dir, Filename As String
	Dir=File.DirApp
	FileNumber=FileNumber+1
	Filename="PDF_"&FileNumber&"_" &DateTime.Now&".pdf"
	Log("Receiving data. Storing file:" & Filename)
	Dim out As OutputStream = File.OpenOutput(Dir, Filename, False)
	out.WriteBytes(Buffer, 0, Buffer.Length)
	out.Close
End Sub


